#include "StdAfx.h"
#include "WASSetUserProfile.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASSetUserProfile::CWASSetUserProfile(CWASActor *pActor) : 
	CWASCommand(pActor)
{
}


CWASSetUserProfile::~CWASSetUserProfile(void)
{
}


void CWASSetUserProfile::ExecuteAsync()
{
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	std::string szInviteOption;
	StringUtil::itoa((int)m_sUserProfile.eInviteAllowType, szInviteOption, 10);
	
	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/MyTalkName.php");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("nickName", W2U8((LPCWSTR)m_sUserProfile.strTalkName.c_str()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	m_httpFacade.session().AddBodyVariable("action", "set");	
	
	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}


bool CWASSetUserProfile::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	// Nothing to do..
	return true;
}


// override in drived class
void CWASSetUserProfile::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int nHttpResponseCode, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{

	int nWASCode = atoi(szWasResCodeInXml);

	if(nWASCode == 200)
	{
		// WAS ѱ  ƹ͵    쿣 WAS 200  ѱ.
		//   200 ETC ̴.
		//     .
		// WAS   ڵ尪 ҴϿ ѱ   ϴ.
		//    .

		m_eError = wasError_NotAffectedRow;
	}

	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	GT_USER_PROFILE_DATA sData;
	m_sUserProfile.Convert(sData);

	if(m_eError == wasError_None)
	{
		CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
		if(pMessengerActor)
		{
			pMessengerActor->SetUserProfile(m_sUserProfile);
			
			pMessengerActor->SendMyTalkName(sData.strTalkName);
		}	
	}

	int a = observers.size();

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseSetUserProfile(m_pActor, GetID(), m_eError, sData) == false)
			break;
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASSetUserProfile::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	GT_USER_PROFILE_DATA sData;
	m_sUserProfile.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseSetUserProfile(m_pActor, GetID(), m_eError, sData) == false)
			break;
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
